﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridSelectionCase
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            ObservableCollection<SampleData> data = new ObservableCollection<SampleData>();

            for(int i=0; i<10; i++)
            {
                for(int j=0; j <2; j++)
                {
                    data.Add(new SampleData() { ID = i, Number = r.Next(1000) });
                }
            }

            ultraGrid1.BeforeRowUpdate += UltraGrid1_BeforeRowUpdate;
            ultraGrid1.DataSource = data;
        }

        private void UltraGrid1_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
        {
            SampleData sd = e.Row.ListObject as SampleData;

            UltraGridRow newRowSelection = null;

            foreach (UltraGridRow row in ultraGrid1.Rows)
            {
                if (row != e.Row && ((row.ListObject as SampleData).ID == sd.ID))
                {
                    newRowSelection = row;
                    break;
                }
            }

            if (newRowSelection != null)
            {
                ultraGrid1.BeforeRowUpdate -= UltraGrid1_BeforeRowUpdate;               
                e.Row.Update();
                e.Cancel = true;                
                ultraGrid1.Selected.Rows.Add(newRowSelection);
                ultraGrid1.ActiveRow = newRowSelection;
                ultraGrid1.BeforeRowUpdate += UltraGrid1_BeforeRowUpdate;
            }
        }
    }

    public class SampleData
    {
        public int ID { get; set; }
        public int Number { get; set; }
    }
}
